

DynamicLinkLibrary variableByteSubclass: #SmartBitmapDLL
  classVariableNames: ''
  poolDictionaries: ''
  category: 'JOOP7'
!

!SmartBitmapDLL class methodsFor: 'private'!
  
startUp
	"When starting up Smalltalk, do the following."
	"SmartBitmapLibrary isNil ifTrue: [
		SmartBitmapLibrary := SmartBitmapDLL open]"
!

fileName
	^'reader.dll'
!
 
exit
	"When exiting Smalltalk, do the following."
	"SmartBitmapLibrary notNil ifTrue: [
		SmartBitmapLibrary close.
		SmartBitmapLibrary := nil]"
! !

!SmartBitmapDLL class methodsFor: 'public interfacing'!
  
bitmapFromFile: fileName
	"SmartBitmapDLL bitmapFromFile: 'flare.lum'."
	| bitmap pen smartBitmap width height colors red green blue alpha |
	smartBitmap := SmartBitmapLibrary smartReadOpen: fileName.
	smartBitmap = 0 ifTrue: [^nil].

	width := SmartBitmapLibrary smartWidth: smartBitmap.
	height := SmartBitmapLibrary smartHeight: smartBitmap.
	colors := ByteArray new: 4.

	bitmap := Bitmap screenWidth8: width height:  height.
	pen := bitmap pen.
	1 to: width do: [:x |
		1 to: height do: [:y |
			SmartBitmapLibrary
				smartAt: smartBitmap at: x-1 and: y-1 into: colors.
			red := colors at: 1. green := colors at: 2.
			blue := colors at: 3. alpha := colors at: 4.
			pen setPixel: x@y color: (RGBColor red: red green: green blue: blue)]].

	SmartBitmapLibrary smartClose: smartBitmap.
	^bitmap
! !


!SmartBitmapDLL methodsFor: 'public interfacing'!
   
with: smartBitmapPointer at: x and: y get: byteArray
	<c: smartAt long long long struct none>
	^self invalidArgument
!
   
with: smartBitmapPointer at: x and: y put: byteArray
	<c: smartAtPut long long long struct none>
	^self invalidArgument
!
 
smartWidth: smartBitmapPointer
	<c: smartWidth long long>
	^self invalidArgument
!
   
smartClose: smartBitmapPointer
	<c: smartClose long none>
	^self invalidArgument
!
   
smartHeight: smartBitmapPointer
	<c: smartHeight long long>
	^self invalidArgument
!
  
smartWriteOpen: fileName width: width height: height
	<c: smartWriteOpen struct long long long>
	^self invalidArgument
!
 
smartReadOpen: fileName
	<c: smartReadOpen struct long>
	^self invalidArgument
! !
SmartBitmapDLL comment: ''!
